local bar = _G[...]
local modName = ...

--Unit Menu
local component = bar:NewComponent('drop', 'Button')

function component:New(parent)
	local name = ('%s_%s_UnitMenu'):format(modName, parent.id)
	if _G[name] then
		return _G[name]
	end
	local button = self:Bind(CreateFrame('Frame', name, parent.box, 'UIDropDownMenuTemplate'))
	if button then
		button.owner = parent
	end
	return button
end

function component:GetDefaults()
    return {}
end

function component:Initialize()
	local menu
	local name
	local unit = self.id
	local id = nil
	if ( UnitIsUnit(unit, 'player') ) then
		menu = 'SELF'
	elseif ( UnitIsUnit(unit, 'vehicle') ) then
		menu = 'VEHICLE'
	elseif ( UnitIsUnit(unit, 'pet') ) then
		menu = 'PET'
	elseif ( UnitIsOtherPlayersBattlePet(unit) ) then
		menu = 'OTHERBATTLEPET'
	elseif ( UnitIsBattlePet(unit) ) then
		menu = 'BATTLEPET'
	elseif ( UnitIsOtherPlayersPet(unit) ) then
		menu = 'OTHERPET'	
	elseif ( UnitIsPlayer(unit) ) then
		id = UnitInRaid(unit)
		if ( id ) then
			menu = 'RAID_PLAYER'
		elseif ( UnitInParty(unit) ) then
			menu = 'PARTY'
		else
			menu = 'PLAYER'
		end
	else
		menu = 'TARGET'
		name = RAID_TARGET_ICON
	end
	if ( menu ) then
		return L_UnitPopup_ShowMenu(self, menu, unit, name, id)
	end
end

local function SetMenuFunc(frame, menuFunc)	
	L_UIDropDownMenu_Initialize(frame.dropDown, menuFunc, "MENU");
	frame.menu = function()
	--(level, value, dropDownFrame, anchorName, xOffset, yOffset, menuList, button, autoHideDelay)
		L_ToggleDropDownMenu(1, 1, frame.dropDown, frame:GetName(), 0, 0);
	end
end

function component:Load()
	self.id = self.owner.id
	self.owner.box.dropDown = self
	self.owner.box.id = self.owner.id
	self.owner.box:SetAttribute('*type1', self.id)
	self.owner.box:SetAttribute('*type2', 'menu')
	self.owner.box:RegisterForClicks('LeftButtonUp', 'RightButtonUp')
	if self.Initialize then
		SetMenuFunc(self.owner.box, self.Initialize)
	end
end
