local bar = _G[...]
local modName = ...
local title = "Health"
--Health Bar
local component = bar:GetTemplate("StatusBar", title)

function component:New(parent)
	return self:Bind(self:CreateNew(parent, title))
end


function component:OnUpdate()
	local unit = self.owner.id
	local dead = UnitIsGhost(unit) or UnitIsDead(unit)
	local deadText
	if dead then
		deadText = "Dead"
	end
	
	
	self:SetValues(UnitHealth(unit), 0, UnitHealthMax(unit), dead, deadText)
	
	local r, g, b
	if not UnitIsConnected(unit) then
		r, g, b = .5, .5, .5
	else
		if self.sets.classColor then
			local localizedClass, englishClass = UnitClass(unit)
			local classColor = RAID_CLASS_COLORS[englishClass]
			if ( classColor ) then
				r, g, b = classColor.r, classColor.g, classColor.b
			else

			end
		else
			if ( UnitIsFriend('player', unit) ) then
				r, g, b = 0.0, 1.0, 0.0
			else
				r, g, b = 1.0, 0.0, 0.0
			end
		end
	end
	if dead then
		r, g, b = r-.75, g-.75, b-.75
	end
	
	self:SetColor(r, g, b, 1)
end

component.options = {
                    {
                        name = 'Class Colored',
                        kind = 'CheckButton',
                        key = 'classColor',
						panel = "texture",
                    },

}
--[[
function component:CreateMenu(menu)
    return bar.Menu.NewMenu(self, menu, 'Health', {

                {
                    name = 'Enable',
                    kind = 'CheckButton',
                    key = 'enable',
					panel = "basic",
                },
                {
                    name = 'Opacity',
                    kind = 'Slider',
                    key = 'alpha',
                    min = 0,
                    max = 100,
					panel = "basic",
                },

                {
                    name = 'Texture',
                    kind = 'Media',
                    key = 'textureName',
                    mediaType = 'StatusBar',
                    handler = 'health',
					panel = "basic",
                },
                {
                    name = 'Rotate 90',
                    kind = 'CheckButton',
                    key = 'rotate',
					panel = "basic",
                },
                {
                    name = 'Growth',
                    kind = 'Menu',
                    key = 'orient',
                    table = {"HORIZONTAL", "VERTICAL"},
					panel = "basic",
                },
                {
                    name = 'Backdrop',
                    kind = 'CheckButton',
                    key = 'showBG',
					panel = "basic",
                },
                {
                    name = 'Background Alpha',
                    kind = 'Slider',
                    key = 'backdropOpacity',
                    min = 0,
                    max = 100,
					panel = "basic",
                },

                {
                    name = 'Text Anchor',
                    kind = 'Menu',
                    key = 'anchorText',
                    table = {
                        'TopLeft',
                        'Top',
                        'TopRight',
                        'Right',
                        'BottomRight',
                        'Bottom',
                        'BottomLeft',
                        'Left',
                        'Center',
                    },
					panel = "text",
                },
                {
                    name = 'Max Width',
                    kind = 'Slider',
                    key = 'maxTextWidth',
                    min = 1,
                    max = 300,
					panel = "text",
                },
                {
                    name = 'Text Y offset',
                    kind = 'Slider',
                    key = 'textY',
                    min = -150,
                    max = 150,
					panel = "text",
                },
                {
                    name = 'Text X offset',
                    kind = 'Slider',
                    key = 'textX',
                    min = -150,
                    max = 150,
					panel = "text",
                },
                {
                    name = 'Curve offset',
                    kind = 'Slider',
                    key = 'CurveOffset',
                    min = -150,
                    max = 150,
					panel = "text",
                },	
                {
                    name = 'Arc',
                    kind = 'Slider',
                    key = 'arc',
                    min = -300,
                    max = 300,
					panel = "text",
                },
                {
                    name = 'Reverse Arc',
                    kind = 'CheckButton',
                    key = 'reverseArc',
					panel = "text",
                },


                    {
                        name = 'Anchor',
                        kind = 'Menu',
                        key = 'anchor',
                        table = {
                            'TopLeft',
                            'Top',
                            'TopRight',
                            'Right',
                            'BottomRight',
                            'Bottom',
                            'BottomLeft',
                            'Left',
                            'Center',
                        },
						panel = "advanced",
                    },
                    {
                        name = 'Frame Level',
                        kind = 'Slider',
                        key = 'frameLevel',
                        min = 1,
                        max = 100,
						panel = "advanced",
                    },	
                    {
                        name = 'Frame Layer',
                        kind = 'Slider',
                        key = 'frameLayer',
                        min = 1,
                        max = 8,
						panel = "advanced",
                    },
                    {
                        name = 'Width',
                        kind = 'Slider',
                        key = 'width',
                        min = 10,
                        max = 400,
						panel = "advanced",
                    }, 
                    {
                        name = 'Height',
                        kind = 'Slider',
                        key = 'height',
                        min = 10,
                        max = 200,
						panel = "advanced",
                    },
                    {
                        name = 'X Offset',
                        kind = 'Slider',
                        key = 'x',
                        min = -400,
                        max = 400,
						panel = "advanced",
                    },
                    {
                        name = 'Y Offset',
                        kind = 'Slider',
                        key = 'y',
                        min = -400,
                        max = 400,
						panel = "advanced",
                    },
                    {
                        name = 'Tooltip',
                        kind = 'CheckButton',
                        key = 'mouseOverTooltip',
						panel = "advanced",
                    },

        }, 1)
end


--]]