
PowerBarColor = {};
PowerBarColor["MANA"] = { r = 0.00, g = 0.00, b = 1.00 };
PowerBarColor["RAGE"] = { r = 1.00, g = 0.00, b = 0.00, fullPowerAnim=true };
PowerBarColor["FOCUS"] = { r = 1.00, g = 0.50, b = 0.25, fullPowerAnim=true };
PowerBarColor["ENERGY"] = { r = 1.00, g = 1.00, b = 0.00, fullPowerAnim=true };
PowerBarColor["COMBO_POINTS"] = { r = 1.00, g = 0.96, b = 0.41 };
PowerBarColor["RUNES"] = { r = 0.50, g = 0.50, b = 0.50 };
PowerBarColor["RUNIC_POWER"] = { r = 0.00, g = 0.82, b = 1.00 };
PowerBarColor["SOUL_SHARDS"] = { r = 0.50, g = 0.32, b = 0.55 };
PowerBarColor["LUNAR_POWER"] = { r = 0.30, g = 0.52, b = 0.90, atlas="_Druid-LunarBar" };
PowerBarColor["HOLY_POWER"] = { r = 0.95, g = 0.90, b = 0.60 };
PowerBarColor["MAELSTROM"] = { r = 0.00, g = 0.50, b = 1.00, atlas = "_Shaman-MaelstromBar", fullPowerAnim=true };
PowerBarColor["INSANITY"] = { r = 0.40, g = 0, b = 0.80, atlas = "_Priest-InsanityBar"};
PowerBarColor["CHI"] = { r = 0.71, g = 1.0, b = 0.92 };
PowerBarColor["ARCANE_CHARGES"] = { r = 0.1, g = 0.1, b = 0.98 };
PowerBarColor["FURY"] = { r = 0.788, g = 0.259, b = 0.992, atlas = "_DemonHunter-DemonicFuryBar", fullPowerAnim=true };
PowerBarColor["PAIN"] = { r = 255/255, g = 156/255, b = 0, atlas = "_DemonHunter-DemonicPainBar", fullPowerAnim=true };
-- vehicle colors
PowerBarColor["AMMOSLOT"] = { r = 0.80, g = 0.60, b = 0.00 };
PowerBarColor["FUEL"] = { r = 0.0, g = 0.55, b = 0.5 };
PowerBarColor["STAGGER"] = { {r = 0.52, g = 1.0, b = 0.52}, {r = 1.0, g = 0.98, b = 0.72}, {r = 1.0, g = 0.42, b = 0.42},};

-- these are mostly needed for a fallback case (in case the code tries to index a power token that is missing from the table,
-- it will try to index by power type instead)
PowerBarColor[0] = PowerBarColor["MANA"];
PowerBarColor[1] = PowerBarColor["RAGE"];
PowerBarColor[2] = PowerBarColor["FOCUS"];
PowerBarColor[3] = PowerBarColor["ENERGY"];
PowerBarColor[4] = PowerBarColor["CHI"];
PowerBarColor[5] = PowerBarColor["RUNES"];
PowerBarColor[6] = PowerBarColor["RUNIC_POWER"];
PowerBarColor[7] = PowerBarColor["SOUL_SHARDS"];
PowerBarColor[8] = PowerBarColor["LUNAR_POWER"];
PowerBarColor[9] = PowerBarColor["HOLY_POWER"];
PowerBarColor[11] = PowerBarColor["MAELSTROM"];
PowerBarColor[13] = PowerBarColor["INSANITY"];
PowerBarColor[17] = PowerBarColor["FURY"];
PowerBarColor[18] = PowerBarColor["PAIN"];


local bar = _G[...]
local modName = ...
local title = "Power"
--Power Bar
local component = bar:GetTemplate("StatusBar", title)
component.Events = {
	["UNIT_POWER"] = 1,
}

function component:New(parent)
	local comp = self:Bind(self:CreateNew(parent, title))

	return comp
end

local basePower = {
        [0] = {
            ["Druid"] = true,
            ["Warlock"] = true,
            ["Shaman"] = true,
            ["Mage"] = true,
            ["Monk"] = true,
            ["Paladin"] = true,
            ["Priest"] = true,
        },
        [1] = {
            ["Warrior"] = true
        },
        [6] = {
            ["Death Knight"] = true
        },
        [3] = {
            ["Rogue"] = true
        }
}


function component:UpdateType()

		local unit = self.owner.id

	local powerType, powerToken, altR, altG, altB = UnitPowerType(unit);
	local prefix = _G[powerToken];
	local info = PowerBarColor[powerToken];
	if ( info ) then
		if ( not self.lockColor ) then
			local playerDeadOrGhost = (UnitIsDead("player") or UnitIsGhost("player"));
				if ( playerDeadOrGhost ) then
					self:SetColor(0.6, 0.6, 0.6, 0.5)
				else
					self:SetColor(info.r, info.g, info.b, 1)
				end
		end
	else
		if ( not altR) then
			-- couldn't find a power token entry...default to indexing by power type or just mana if we don't have that either
			info = PowerBarColor[powerType] or PowerBarColor["MANA"];
		else
			if ( not self.lockColor ) then
				self:SetColor(altR, altG, altB, 1)
			end
		end
	end
	if ( self.powerType ~= powerType or self.powerType ~= powerType ) then
		self.powerType = powerType;
		self.powerToken = powerToken;
		if ( self.FullPowerFrame ) then
		--	self.FullPowerFrame:RemoveAnims();
		end
		--self.currValue = UnitPower("player", powerType);
	end

	-- Update the manabar text
	if ( not self.noTextPrefix ) then
	--	SetTextStatusBarTextPrefix(self, prefix);
	end
	--TextStatusBar_UpdateTextString(self);
end


function component:ShouldDisplayPower()
	local unit = self.owner.id
	if UnitHasVehiclePlayerFrameUI(unit) then
		return false;
	end

	if UnitPowerMax(unit, self.powerIndex) == 0 then
		return false;
	end

	local _, class = UnitClass(unit);
	if ALT_MANA_BAR_PAIR_DISPLAY_INFO[class] then
		local powerType = UnitPowerType(unit);
		return ALT_MANA_BAR_PAIR_DISPLAY_INFO[class][powerType];
	end

	return false;
end


function component:OnUpdate()
	if not self:ShouldDisplayPower() then
		self:Hide()
		return
	else
		self:Show()
	end
	local unit = self.owner.id
	
	local basePower_index = basePower[UnitClass(unit)]
	local Max = UnitPowerMax(unit)
	local current = UnitPower(unit)
	
	local dead = UnitIsGhost(unit) or UnitIsDead(unit)

	
	if UnitPowerType(unit) and basePower[UnitPowerType(unit)] and basePower[UnitPowerType(unit)][UnitClass(unit)] then
	    Max = nil
		current = nil
		dead = true
	end
	

	
	
	
	self:SetValues(current, 0, Max, dead)
	--[[
	local r, g, b
	if ( not UnitIsConnected(unit)) then
		r, g, b = 0.5, 0.5, 0.5
	else
		local powerType, powerToken, altR, altG, altB = UnitPowerType(unit, basePower_index)
		powerType = basePower_index
		local info = PowerBarColor[powerToken]
		if ( info ) then
			r, g, b = info.r, info.g, info.b
		else
			if ( not altR) then
				info = PowerBarColor[powerType] or PowerBarColor['MANA']
				r, g, b = info.r, info.g, info.b
			else
				r, g, b = altR, altG, altB
			end
		end
	end
	if dead then
		r, g, b = r-.75, g-.75, b-.75
	end
	
	self:SetColor(r, g, b, 1)
	--]]
	self:UpdateType()
	
end
--[[
component.options = {
                    {
                        name = 'Texture',
                        kind = 'Media',
                        key = 'textureName',
                        mediaType = 'StatusBar',
                        handler = string.lower(title),
						panel = "texture",
                    },
}



function component:CreateMenu(menu)
    return bar.Menu.NewMenu(self, menu, 'Power', {

                {
                    name = 'Enable',
                    kind = 'CheckButton',
                    key = 'enable',
					panel = "basic",
                },
                {
                    name = 'Opacity',
                    kind = 'Slider',
                    key = 'alpha',
                    min = 0,
                    max = 100,
					panel = "basic",
                },

                {
                    name = 'Texture',
                    kind = 'Media',
                    key = 'textureName',
                    mediaType = 'StatusBar',
                    handler = 'power',
					panel = "basic",
                },
                {
                    name = 'Rotate 90',
                    kind = 'CheckButton',
                    key = 'rotate',
					panel = "basic",
                },
                {
                    name = 'Growth',
                    kind = 'Menu',
                    key = 'orient',
                    table = {"HORIZONTAL", "VERTICAL"},
					panel = "basic",
                },
                {
                    name = 'Backdrop',
                    kind = 'CheckButton',
                    key = 'showBG',
					panel = "basic",
                },
                {
                    name = 'Background Alpha',
                    kind = 'Slider',
                    key = 'backdropOpacity',
                    min = 0,
                    max = 100,
					panel = "basic",
                },

                {
                    name = 'Text Anchor',
                    kind = 'Menu',
                    key = 'anchorText',
                    table = {
                        'TopLeft',
                        'Top',
                        'TopRight',
                        'Right',
                        'BottomRight',
                        'Bottom',
                        'BottomLeft',
                        'Left',
                        'Center',
                    },
					panel = "text",
                },
                {
                    name = 'Max Width',
                    kind = 'Slider',
                    key = 'maxTextWidth',
                    min = 1,
                    max = 300,
					panel = "text",
                },
                {
                    name = 'Text Y offset',
                    kind = 'Slider',
                    key = 'textY',
                    min = -150,
                    max = 150,
					panel = "text",
                },
                {
                    name = 'Text X offset',
                    kind = 'Slider',
                    key = 'textX',
                    min = -150,
                    max = 150,
					panel = "text",
                },
                {
                    name = 'Curve offset',
                    kind = 'Slider',
                    key = 'CurveOffset',
                    min = -150,
                    max = 150,
					panel = "text",
                },	
                {
                    name = 'Arc',
                    kind = 'Slider',
                    key = 'arc',
                    min = -300,
                    max = 300,
					panel = "text",
                },
                {
                    name = 'Reverse Arc',
                    kind = 'CheckButton',
                    key = 'reverseArc',
					panel = "text",
                },


                    {
                        name = 'Anchor',
                        kind = 'Menu',
                        key = 'anchor',
                        table = {
                            'TopLeft',
                            'Top',
                            'TopRight',
                            'Right',
                            'BottomRight',
                            'Bottom',
                            'BottomLeft',
                            'Left',
                            'Center',
                        },
						panel = "advanced",
                    },
                    {
                        name = 'Frame Level',
                        kind = 'Slider',
                        key = 'frameLevel',
                        min = 1,
                        max = 100,
						panel = "advanced",
                    },	
                    {
                        name = 'Frame Layer',
                        kind = 'Slider',
                        key = 'frameLayer',
                        min = 1,
                        max = 8,
						panel = "advanced",
                    },
                    {
                        name = 'Width',
                        kind = 'Slider',
                        key = 'width',
                        min = 10,
                        max = 400,
						panel = "advanced",
                    }, 
                    {
                        name = 'Height',
                        kind = 'Slider',
                        key = 'height',
                        min = 10,
                        max = 200,
						panel = "advanced",
                    },
                    {
                        name = 'X Offset',
                        kind = 'Slider',
                        key = 'x',
                        min = -400,
                        max = 400,
						panel = "advanced",
                    },
                    {
                        name = 'Y Offset',
                        kind = 'Slider',
                        key = 'y',
                        min = -400,
                        max = 400,
						panel = "advanced",
                    },
                    {
                        name = 'Tooltip',
                        kind = 'CheckButton',
                        key = 'mouseOverTooltip',
						panel = "advanced",
                    },

        }, 1)
end

--]]

