local bar = _G[...]
local modName = ...

--Unit Button
local component = bar:NewComponent('box', 'Button')

function component:New(parent)
	local name = ('%s_%s_UnitButton'):format(modName, parent.id)
	if _G[name] then
		return _G[name]
	end
	local button = self:Bind(CreateFrame('Button', name, parent, 'SecureUnitButtonTemplate'))
	button:SetParent(parent.header)
	button.owner = parent
	parent.box = button
	return button
end

function component:OnEnter()
	self.unit = self.owner.id
	UnitFrame_OnEnter(self)
end

function component:OnLeave()
	UnitFrame_OnLeave(self)
end

local isrunning


local Events = {}

function component:OnUpdate(event, unit)
	if (not self.isrunning) then--and (unit == self.owner.id) then
		self.isrunning = true
	
		local components = self.owner.components
		if not components then
			return
		end
		local hasMouse

			
		for i , component in pairs(components) do
			if component.Update then--and (component[event]) then
				component:Update(event)
			end

			if (MouseIsOver(component) and ((component.sets and component.sets.mouseOverTooltip) or (not component.sets)) and component:IsShown()) and (not hasMouse) and (not component.noMouse) then
				hasMouse = component
				--break
			end
		end
		if hasMouse and MouseIsOver(hasMouse) then
			if self.lastMouse ~= hasMouse then
				local ent = hasMouse:GetScript('OnEnter')

				if ent then
					--ent(hasMouse)
				else
					self:OnEnter()
				end
			end
			self.lastMouse = hasMouse
		else
			if self.lastMouse then
				self:OnLeave()
				self.lastMouse = nil
			end
		end
		self.isrunning = nil
	end
end

function component:Layout()
    if InCombatLockdown() then
        return
    end
	local w, h = self.owner.sets.width or 10, self.owner.sets.height or 10
	local padW, padH = self.owner:GetPadding()

	self.owner:SetSize(w + (padW*1.5), h + (padH*1.5))
	self:SetSize(w, h)
end


function component:Load()
	self:EnableMouse(true)
	self.unit = self.owner.id
	self:SetAttribute('unit', self.unit)
	RegisterUnitWatch(self)
	Dominos_Units = {}
	
	--[[
	if component.Events then
		for event, b in pairs(component.Events) do
			Events[event] = Events[event] or {}
			
			tinsert(Events[event], self)
			tinsert(Dominos_Units, event)
	
			self:RegisterEvent(event)
			self:RegisterUnitEvent(event, self.owner.id)
		end
	end
	--]]
	--		self:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
	--		self:RegisterUnitEvent("UPDATE_MOUSEOVER_UNIT", self.owner.id)
			
	self:SetScript('OnUpdate', self.OnUpdate)
	self:SetPoint('Center', self.owner)
end

