local Events = {}
local eventManager = {}
local frameHandler = {}


function Events:PLAYER_ENTER_COMBAT()
	frameHandler.PLAYER_ENTER_COMBAT = {}
	local COMBAT
	for unit, frame in pairs(eventManager.PLAYER_ENTER_COMBAT) do
		local inCombat = UnitAffectingCombat(unit)
		if inCombat then
			if eventManager.PLAYER_ENTER_COMBAT[unit] ~= inCombat then
				eventManager.PLAYER_ENTER_COMBAT[unit] = inCombat
				frameHandler.PLAYER_ENTER_COMBAT[unit] = frame
				COMBAT =  "PLAYER_ENTER_COMBAT"
		else
			eventManager.PLAYER_ENTER_COMBAT[unit] = nil
		end
	end
	if COMBAT then
		return COMBAT, frameHandler.PLAYER_ENTER_COMBAT
	end
end

function Events:PLAYER_LEAVE_COMBAT()
	frameHandler.PLAYER_LEAVE_COMBAT = {}
	local NOCOMBAT
	for unit, frame in pairs(eventManager.PLAYER_LEAVE_COMBAT) do
		local inCombat = UnitAffectingCombat(unit)
		if not inCombat then
			if eventManager.PLAYER_LEAVE_COMBAT[unit] ~= true then
				eventManager.PLAYER_LEAVE_COMBAT[unit] = true
				frameHandler.PLAYER_LEAVE_COMBAT[unit] = frame
				NOCOMBAT =  "PLAYER_LEAVE_COMBAT"
			end
		else
			eventManager.PLAYER_LEAVE_COMBAT[unit] = nil
		end
	end
	if NOCOMBAT then
		return NOCOMBAT, frameHandler.PLAYER_LEAVE_COMBAT
	end
end
do
	local updateDelay = 1 --only updatethe texture, once per second, or when target changes.
	local Time
	function Events:UNIT_PORTRAIT_UPDATE()
		local t = GetTime()
		Time = Time or GetTime()
		if math.abs(t - Time) >= updateDelay then
			frameHandler.UNIT_PORTRAIT_UPDATE = {}
			for unit, frame in pairs(eventManager.UNIT_PORTRAIT_UPDATE) do
				if eventManager.UNIT_PORTRAIT_UPDATE[unit] ~= true then
					eventManager.UNIT_PORTRAIT_UPDATE[unit] = true
					frameHandler.UNIT_PORTRAIT_UPDATE[unit] = frame
				end
			end
			return true, frameHandler.UNIT_PORTRAIT_UPDATE
		end
	end
end

Dominos_Units = {

	
	["UNIT_PORTRAIT_UPDATE"] = function()
		
			
		
	end, -- [2]
	["PARTY_LOOT_METHOD_CHANGED"] = function() end, -- [3]
	["UNIT_SPELLCAST_CHANNEL_START"] = function() end, -- [4]
	["UNIT_SPELLCAST_INTERRUPTIBLE"] = function() end, -- [5]
	["UNIT_CLASSIFICATION_CHANGED"] = function() end, -- [6]
	["PLAYER_UPDATE_RESTING"] = function() end, -- [7]
	["UNIT_LEVEL"] = function() end, -- [8]
	["LFG_ROLE_CHECK_HIDE"] = function() end, -- [9]
	["UNIT_NAME_UPDATE"] = function() end, -- [10]
	["UNIT_SPELLCAST_NOT_INTERRUPTIBLE"] = function() end, -- [11]
	["PVP_ROLE_UPDATE"] = function() end, -- [12]
	["UNIT_THREAT_SITUATION_UPDATE"] = function() end, -- [13]
	["LFG_BONUS_FACTION_ID_UPDATED"] = function() end, -- [14]
	["UNIT_SPELLCAST_CHANNEL_UPDATE"] = function() end, -- [15]
	["UNIT_MODEL_CHANGED"] = function() end, -- [16]
	["CURRENCY_DISPLAY_UPDATE"] = function() end, -- [17]
	["0UNIT_MANA"] = function() end, -- [18]
	["LFG_ROLE_CHECK_SHOW"] = function() end, -- [19]
	["UNIT_AURA"] = function() end, -- [20]
	["LFG_ROLE_UPDATE"] = function() end, -- [21]
	["UNIT_MODEL_CHANGE"] = function() end, -- [22]
	["UNIT_MANA"] = function() end, -- [23]
	["UNIT_POWER"] = function() end, -- [24]
	["LFG_ROLE_CHECK_ROLE_CHOSEN"] = function() end, -- [25]
	["PLAYER_ROLES_ASSIGNED"] = function() end, -- [26]
	["UNIT_SPELLCAST_START"] = function() end, -- [27]
	["UNIT_SPELLCAST_SENT"] = function() end, -- [28]
	["UNIT_SPELLCAST_DELAYED"] = function() end, -- [29]
	["UNIT_SPELLCAST_FAILED_QUIET"] = function() end, -- [30]
	["LFG_ROLE_CHECK_DECLINED"] = function() end, -- [31]
	["PARTY_LEADER_CHANGED"] = function() end, -- [32]
	["RAID_TARGET_UPDATE"] = function() end, -- [33]
	["UNIT_SPELLCAST_STOP"] = function() end, -- [34]
	["PLAYER_TARGET_CHANGED"] = function() end, -- [35]
	["UPDATE_FACTION"] = function() end, -- [36]
	["ROLE_CHANGED_INFORM"] = function() end, -- [37]
	["UNIT_COMBAT"] = function() end, -- [38]
	["PLAYER_MONEY"] = function() end, -- [39]
	["UNIT_TARGETABLE_CHANGED"] = function() end, -- [40]
	["ROLE_POLL_BEGIN"] = function() end, -- [41]
	["LFG_QUEUE_STATUS_UPDATE"] = function() end, -- [42]
	["UNIT_SPELLCAST_INTERRUPTED"] = function() end, -- [43]
	["UNIT_FACTION"] = function() end, -- [44]
	["LFG_ROLE_CHECK_UPDATE"] = function() end, -- [46]
	["UNIT_SPELLCAST_CHANNEL_STOP"] = function() end, -- [47]
	["ARTIFACT_XP_UPDATE"] = function() end, -- [48]
	["ARTIFACT_UPDATE"] = function() end, -- [49]
	["UNIT_THREAT_LIST_UPDATE"] = function() end, -- [50]
	["UNIT_SPELLCAST_SUCCEEDED"] = function() end, -- [51]
	["UNIT_SPELLCAST_FAILED"] = function() end, -- [52]
}
