local modName = ...
local AddonName, AddonTable = ...
--local Addon = LibStub('AceAddon-3.0'):NewAddon(AddonTable, AddonName, 'AceEvent-3.0', 'AceConsole-3.0')
print(type(AddonTable))
local Addon = LibStub('AceAddon-3.0'):GetAddon(GetAddOnDependencies(modName))
local bar = Addon:CreateClass('Frame', Addon.Frame)
_G[modName] = bar

bar.master = Addon
bar.lib = LibStub('LibSharedMedia-3.0', true)

bar.frames = {}

function bar:New(name)
	local name = string.lower(name)
	local f = self.proto.New(self, name)
	f:Reload()
	--f:SetParent(self.header)
	bar.frames[name] = bar.frames[name] or f
	return f
end

local Basics = {
	overlay = {
		enable = true,
	},
	debuffs = {
		columns = 6,
		scale = 76,
		color = {
			a = 1,
			b = 0,
			g = 0,
			r = 0,
		},
		rows = 3,
		isLeftToRight = true,
		x = 0,
		y = -73,
		isTopToBottom = true,
		sort = "Duration",
		spacing = 0,
		anchor = "Top",
		enable = false,
		showBG = false,
		alpha = 100,
	},
	focus = {
		y = -12,
		usePortrait = true,
		mouseOverTooltip = true,
		x = -42,
		enable = true,
		scale = 95,
		alpha = 100,
		anchor = "TopRight",
	},
	level = {
		scale = 100,
		justifyV = 1,
		width = 25,
		y = -16,
		x = 63,
		justifyH = 2,
		height = 12,
		enable = true,
		anchor = "Center",
	},
	threat = {
		scale = 100,
		justifyV = 1,
		width = 35,
		y = 12,
		x = 0,
		justifyH = 3,
		height = 12,
		anchor = "top",
		enable = true,
	},
	power = {
		maxTextWidth = 1000,
		prevOrient = "HORIZONTAL",
		scale = 100,
		justifyV = "CENTER",
		textureName = "Raid",
		xTextOffset = 0,
		textY = 0,
		justifyH = "CENTER",
		drop = true,
		anchor = "TopRight",
		format = "percent",
		texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
		textVert = 2,
		orient = "HORIZONTAL",
		textHori = 2,
		textX = 0,
		mouseover = "value",
		yTextOffset = 0,
		CurveOffset = 0,
		alpha = 100,
		width = 115,
		y = -52,
		x = -111,
		mouseOverTooltip = true,
		arc = 0,
		height = 12,
		anchorText = "Center",
		percent = true,
		enable = true,
	},
	health = {
		maxTextWidth = 300,
		prevOrient = "HORIZONTAL",
		scale = 100,
		justifyV = "CENTER",
		textureName = "Raid",
		justifyH = "CENTER",
		drop = true,
		anchor = "TopRight",
		format = "value",
		texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
		textVert = 2,
		orient = "HORIZONTAL",
		textY = 0,
		textX = 0,
		mouseover = "value",
		textHori = 2,
		CurveOffset = 0,
		alpha = 100,
		width = 115,
		y = -41,
		x = -110,
		mouseOverTooltip = true,
		arc = 0,
		height = 12,
		anchorText = "Center",
		percent = true,
		enable = true,
	},
	icons = {
		alpha = 100,
		scale = 130,
		columns = 8,
		frameLayer = 3,
		enable = true,
		height = 45,
		IsLeftToRight = false,
		width = 45,
		y = 2,
		x = -45,
		style = "ROUND",
		spacing = 0,
		anchor = "Right",
		angle = 313,
		IsTopToBottom = true,
		compress = 0,
	},
	name = {
		enable = true,
		justifyV = 1,
		width = 100,
		y = 19,
		x = -50,
		justifyH = 2,
		anchor = "Center",
		scale = 100,
		height = 12,
	},
	model = {
		zoom = 0,
		frameLevel = 1,
		frameLayer = 1,
		scale = 1,
		justifyV = "CENTER",
		width = 133,
		y = -45,
		x = -110,
		justifyH = "CENTER",
		clickThru = true,
		anchor = "BottomLeft",
		enable = false,
		height = 197,
		rotation = 0,
	},
	buffs = {
		columns = 6,
		color = {
			a = 1,
			b = 0,
			g = 0,
			r = 0,
		},
		scale = 64,
		rows = 1,
		isLeftToRight = true,
		isTopToBottom = false,
		y = 6,
		x = 12,
		sort = "Duration",
		spacing = 0,
		anchor = "BottomLeft",
		enable = false,
		showBG = false,
		alpha = 100,
	},
	cast = {
		maxTextWidth = 98,
		scale = 100,
		sparkY = 0,
		Sparkarc = 0,
		anchor = "Left",
		textureName = "Blizzard",
		texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
		xTextOffset = 0,
		textY = 0,
		frameLevel = 2,
		textX = 0,
		frameLayer = 4,
		yTextOffset = 0,
		CurveOffset = 0,
		alpha = 100,
		width = 117,
		y = 17,
		x = 7,
		mouseOverTooltip = true,
		arc = 0,
		height = 16,
		anchorText = "Center",
		showBG = false,
		enable = true,
	},
	background = {
		edgeSize = 13,
		color = {
			a = 0.5,
			b = 0,
			g = 0,
			r = 0,
		},
		texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
		scale = 100,
		bgPad = 0,
		width = 51,
		textureName = "Blizzard Tooltip",
		y = -26,
		x = -111,
		height = 41,
		edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
		anchor = "TopRight",
		edgecolor = {
			a = 100,
			b = 100,
			g = 100,
			r = 100,
		},
		inset = 0,
		enable = true,
	},

}

local defaults = {
	focus = {
		scale = .75,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'playerBR',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
	},
	targettarget = {
		scale = .75,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'targetRB',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 420,
		padH = 3,
		height = 100,
	},
	target = {
		scale = 1,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		point = 'TopLeft',
		padW = 3,
		width = 232,
		y = 0,
		x = 235,
		padH = 3,
		height = 100,
		debuffs = {
			columns = 6,
			scale = 76,
			color = {
				a = 1,
				b = 0,
				g = 0,
				r = 0,
			},
			rows = 3,
			isLeftToRight = true,
			x = 0,
			y = -73,
			isTopToBottom = true,
			sort = "Duration",
			spacing = 0,
			anchor = "Top",
			enable = true,
			showBG = false,
			alpha = 100,
		},
		buffs = {
			columns = 6,
			color = {
				a = 1,
				b = 0,
				g = 0,
				r = 0,
			},
			scale = 64,
			rows = 1,
			isLeftToRight = true,
			isTopToBottom = false,
			y = 6,
			x = 12,
			sort = "Duration",
			spacing = 0,
			anchor = "BottomLeft",
			enable = true,
			showBG = false,
			alpha = 100,
		},

	},
	player = {
		scale = 1,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		point = 'TopLeft',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
		overlay = {
			enable = true,
		},
		debuffs = {
			columns = 6,
			isLeftToRight = true,
			color = {
				a = 1,
				r = 0,
				g = 0,
				b = 0,
			},
			rows = 3,
			alpha = 100,
			isTopToBottom = true,
			y = -73,
			x = 0,
			sort = "Duration",
			spacing = 0,
			anchor = "Top",
			enable = false,
			showBG = false,
			scale = 76,
		},
		cast = {
			textY = 0,
			enable = true,
			textheight = 12,
			Sparkarc = 0,
			sparkY = 0,
			anchor = "Left",
			texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
			showBG = false,
			CurveOffset = 0,
			yTextOffset = 0,
			xTextOffset = 0,
			frameLevel = 2,
			frameLayer = 4,
			textX = 0,
			maxTextWidth = 98,
			alpha = 100,
			width = 117,
			y = 17,
			x = 225,
			mouseOverTooltip = true,
			arc = 0,
			height = 16,
			anchorText = "Center",
			scale = 100,
			textureName = "Blizzard",
		},
		focus = {
			y = -12,
			x = 42,
			mouseOverTooltip = true,
			enable = true,
			anchor = "TopLeft",
			scale = 95,
			alpha = 100,
			usePortrait = true,
		},
		level = {
			scale = 100,
			justifyV = 1,
			width = 25,
			y = -16,
			x = -63,
			justifyH = 2,
			anchor = "Center",
			enable = true,
			height = 12,
		},
		threat = {
			scale = 100,
			justifyV = 1,
			width = 35,
			y = 12,
			x = 0,
			justifyH = 3,
			height = 12,
			enable = true,
			anchor = "top",
		},
		background = {
			edgeSize = 13,
			inset = 0,
			color = {
				a = 0.5,
				r = 0,
				g = 0,
				b = 0,
			},
			enable = true,
			bgPad = 0,
			edgecolor = {
				a = 100,
				r = 100,
				g = 100,
				b = 100,
			},
			textureName = "Blizzard Tooltip",
			y = -26,
			x = 111,
			width = 51,
			edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			anchor = "TopLeft",
			height = 41,
			texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
			scale = 100,
		},
		power = {
			maxTextWidth = 300,
			prevOrient = "HORIZONTAL",
			scale = 100,
			justifyV = "CENTER",
			textureName = "Raid",
			enable = true,
			yTextOffset = 0,
			justifyH = "CENTER",
			drop = true,
			anchor = "TopLeft",
			format = "percent",
			texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
			textY = 0,
			orient = "HORIZONTAL",
			xTextOffset = 0,
			textVert = 2,
			textHori = 2,
			alpha = 100,
			textX = 0,
			mouseover = "value",
			width = 116,
			y = -52,
			CurveOffset = 0,
			mouseOverTooltip = true,
			arc = 0,
			height = 12,
			anchorText = "Center",
			percent = true,
			x = 109,
		},
		icons = {
			frameLayer = 3,
			enable = true,
			columns = 8,
			compress = 0,
			scale = 130,
			alpha = 100,
			IsLeftToRight = false,
			width = 45,
			y = 2,
			IsTopToBottom = true,
			style = "ROUND",
			spacing = 0,
			height = 45,
			angle = 227,
			x = 45,
			anchor = "Left",
		},
		health = {
			textY = 0,
			prevOrient = "HORIZONTAL",
			scale = 100,
			justifyV = "CENTER",
			textureName = "Raid",
			classColor = false,
			justifyH = "CENTER",
			drop = true,
			anchor = "TopLeft",
			format = "value",
			texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
			enable = true,
			orient = "HORIZONTAL",
			maxTextWidth = 300,
			textVert = 2,
			textX = 0,
			textHori = 2,
			alpha = 100,
			mouseover = "value",
			width = 115,
			y = -41,
			x = 110,
			mouseOverTooltip = true,
			arc = 0,
			height = 12,
			anchorText = "Center",
			percent = true,
			CurveOffset = 0,
		},
		model = {
			zoom = 0,
			frameLevel = 1,
			frameLayer = 1,
			scale = 1,
			justifyV = "CENTER",
			width = 133,
			y = -45,
			x = -110,
			justifyH = "CENTER",
			rotation = 0,
			anchor = "BottomLeft",
			height = 197,
			enable = false,
			clickThru = true,
		},
		buffs = {
			columns = 6,
			isLeftToRight = true,
			scale = 64,
			rows = 1,
			alpha = 100,
			x = 94,
			y = 7,
			isTopToBottom = false,
			sort = "Duration",
			spacing = 0,
			anchor = "BottomLeft",
			enable = false,
			showBG = false,
			color = {
				a = 1,
				r = 0,
				g = 0,
				b = 0,
			},
		},
		name = {
			enable = true,
			justifyV = 1,
			width = 100,
			y = 19,
			x = 50,
			justifyH = 2,
			height = 12,
			scale = 100,
			anchor = "Center",
		},
	},
	focustarget = {
		scale = .7,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'focusRB',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
	},
	playerpet = {
		scale = .75,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'focusBL',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
	},
	vehicle = {
		scale = .75,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'focusBL',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
	},
}


local f =  {
		["player"] = {
			["overlay"] = {
				["y"] = -2,
				["x"] = -21,
				["frameLayer"] = 1,
				["anchor"] = "Center",
				["frameStrata"] = 4,
				["enable"] = true,
			},
			["debuffs"] = {
				["alpha"] = 100,
				["isLeftToRight"] = true,
				["columns"] = 6,
				["frameLayer"] = 1,
				["scale"] = 76,
				["rows"] = 3,
				["frameStrata"] = 2,
				["enable"] = false,
				["y"] = -73,
				["x"] = 0,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "Top",
				["isTopToBottom"] = true,
				["showBG"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
			},
			["resource"] = {
				["rotateIcons"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["g"] = 1,
					["r"] = 1,
				},
				["spacing"] = 3,
				["anchor"] = "Bottom",
				["angle"] = 0,
				["showBG"] = false,
				["columns"] = 5,
				["compress"] = 0,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 50,
				["y"] = 11,
				["isTopToBottom"] = false,
				["style"] = "Bar",
				["scale"] = 91,
				["height"] = 50,
				["x"] = 31,
				["frameLayer"] = 1,
				["frameStrata"] = 2,
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopLeft",
				["format"] = "value",
				["bottomOffset"] = 100,
				["frameLayer"] = 1,
				["mouseover"] = "percent",
				["y"] = -69,
				["x"] = 89,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 91,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["leftOffset"] = 0,
				["LifeTime"] = 0,
				["textVert"] = 2,
				["orient"] = "HORIZONTAL",
				["alpha"] = 100,
				["width"] = 126,
				["enable"] = true,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["textY"] = 0,
				["textX"] = 0,
				["frameStrata"] = 2,
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["padW"] = 3,
			["currency"] = {
				["enable"] = false,
				["Goal"] = {
				},
				["anchor"] = "BottomLeft",
				["showBG"] = false,
				["frameLayer"] = 1,
				["lifeTime_Track"] = {
					[""] = {
					},
					["Artifact Points"] = {
					},
					["Gold"] = {
					},
				},
				["ThisSession"] = {
					[""] = 0,
					["Artifact Points"] = 0,
					["Gold"] = 0,
				},
				["frameStrata"] = 2,
				["width"] = 50,
				["y"] = 6,
				["x"] = 12,
				["alpha"] = 100,
				["scale"] = 64,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["g"] = 1,
					["r"] = 1,
				},
				["isTopToBottom"] = false,
				["watchIndex"] = 2,
				["lifeTime"] = {
					[""] = 0,
					["Artifact Points"] = 0,
					["Gold"] = 0,
				},
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 20,
				["enable"] = true,
				["alpha"] = 100,
				["y"] = -14,
				["x"] = 21,
				["mouseOverTooltip"] = true,
				["anchor"] = "TopLeft",
				["scale"] = 100,
				["frameStrata"] = 3,
			},
			["background"] = {
				["color"] = {
					["a"] = 0.5,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["r"] = 100,
					["g"] = 100,
					["b"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "TopLeft",
				["inset"] = 0,
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 2,
				["width"] = 50,
				["y"] = -26,
				["x"] = 91,
				["height"] = 18,
				["enable"] = true,
				["scale"] = 100,
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			},
			["level"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 25,
				["y"] = -20,
				["x"] = -82,
				["justifyH"] = 2,
				["anchor"] = "Center",
				["enable"] = true,
				["height"] = 12,
				["frameStrata"] = 4,
			},
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = -11,
				["x"] = -10,
				["justifyH"] = 3,
				["height"] = 12,
				["enable"] = true,
				["anchor"] = "top",
				["frameStrata"] = 2,
			},
			["cast"] = {
				["textY"] = 0,
				["scale"] = 100,
				["multi"] = true,
				["textureName"] = "Blizzard",
				["textheight"] = 12,
				["maxTextWidth"] = 98,
				["Sparkarc"] = 0,
				["backdropOpacity"] = 50,
				["showBG"] = false,
				["anchor"] = "Left",
				["textX"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["x"] = 87,
				["orient"] = "HORIZONTAL",
				["alpha"] = 100,
				["frameLevel"] = 2,
				["frameLayer"] = 3,
				["xTextOffset"] = 0,
				["yTextOffset"] = 0,
				["frameStrata"] = 2,
				["width"] = 117,
				["y"] = 17,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 16,
				["anchorText"] = "Center",
				["enable"] = true,
				["sparkY"] = 0,
			},
			["power"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopLeft",
				["format"] = "value",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "percent",
				["yTextOffset"] = 0,
				["x"] = 89,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["scale"] = 91,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["height"] = 12,
				["textVert"] = 2,
				["xTextOffset"] = 0,
				["textX"] = 0,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 126,
				["maxTextWidth"] = 300,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 2,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["y"] = -56,
				["topOffset"] = 0,
			},
			["icons"] = {
				["xShift"] = 0,
				["yShift"] = 0,
				["enable"] = true,
				["scale"] = 101,
				["spin"] = -154,
				["compress"] = 0,
				["spacing"] = 0,
				["space"] = -13,
				["angle"] = 227,
				["rings"] = 1,
				["frameStrata"] = 2,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 8,
				["frameLayer"] = 3,
				["width"] = 45,
				["IsTopToBottom"] = true,
				["IsLeftToRight"] = false,
				["xArc"] = 0,
				["y"] = 4,
				["x"] = 24,
				["style"] = "ROUND",
				["yArc"] = 0,
				["height"] = 45,
				["xFlex"] = 0,
				["alpha"] = 100,
				["anchor"] = "Left",
			},
			["showInOverrideUI"] = false,
			["frameStrata"] = 4,
			["width"] = 232,
			["padH"] = 3,
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 1,
				["width"] = 100,
				["y"] = 16,
				["x"] = 29,
				["justifyH"] = 2,
				["height"] = 12,
				["scale"] = 100,
				["anchor"] = "Center",
				["frameStrata"] = 2,
			},
			["health"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopLeft",
				["format"] = "value",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "percent",
				["y"] = -44,
				["x"] = 89,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 91,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["textX"] = 0,
				["textVert"] = 2,
				["enable"] = true,
				["textY"] = 0,
				["alpha"] = 100,
				["width"] = 126,
				["classColor"] = false,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["leftOffset"] = 0,
				["frameStrata"] = 1,
				["bottomOffset"] = 100,
				["height"] = 12,
				["topOffset"] = 0,
			},
			["model"] = {
				["zoom"] = 0,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 1,
				["rotation"] = 0,
				["justifyV"] = "CENTER",
				["width"] = 133,
				["y"] = -45,
				["x"] = -110,
				["justifyH"] = "CENTER",
				["anchor"] = "BottomLeft",
				["height"] = 197,
				["enable"] = false,
				["clickThru"] = true,
				["frameStrata"] = 2,
			},
			["height"] = 100,
			["buffs"] = {
				["alpha"] = 100,
				["isLeftToRight"] = true,
				["columns"] = 6,
				["frameLayer"] = 1,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["rows"] = 1,
				["frameStrata"] = 2,
				["enable"] = false,
				["y"] = 0,
				["isTopToBottom"] = false,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["x"] = 94,
				["showBG"] = false,
				["scale"] = 64,
			},
			["frameLayer"] = 4,
			["scale"] = 1,
		},
		["focus"] = {
			["overlay"] = {
				["y"] = -1,
				["x"] = 11,
				["frameLayer"] = 3,
				["enable"] = true,
				["frameStrata"] = 4,
				["anchor"] = "Center",
			},
			["debuffs"] = {
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 1,
					["b"] = 0.0666666666666667,
				},
				["rows"] = 1,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "Bottom",
				["showBG"] = false,
				["columns"] = 6,
				["frameLayer"] = 1,
				["isLeftToRight"] = true,
				["y"] = -39,
				["isTopToBottom"] = true,
				["alpha"] = 100,
				["reverse"] = false,
				["frameStrata"] = 5,
				["scale"] = 64,
				["enable"] = true,
				["x"] = -39,
			},
			["resource"] = {
				["rotateIcons"] = 0,
				["enable"] = true,
				["spacing"] = 3,
				["anchor"] = "Bottom",
				["angle"] = 0,
				["showBG"] = false,
				["columns"] = 5,
				["compress"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["g"] = 1,
					["r"] = 1,
				},
				["frameStrata"] = 2,
				["width"] = 50,
				["y"] = 11,
				["isTopToBottom"] = false,
				["style"] = "Bar",
				["scale"] = 91,
				["height"] = 50,
				["x"] = -31,
				["frameLayer"] = 1,
				["alpha"] = 100,
			},
			["scale"] = 1,
			["cast"] = {
				["textY"] = 0,
				["scale"] = 100,
				["multi"] = true,
				["textureName"] = "Blizzard",
				["sparkY"] = 0,
				["maxTextWidth"] = 98,
				["Sparkarc"] = 0,
				["backdropOpacity"] = 50,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["anchor"] = "Right",
				["textX"] = 0,
				["showBG"] = false,
				["CurveOffset"] = 0,
				["orient"] = "HORIZONTAL",
				["alpha"] = 100,
				["frameLevel"] = 2,
				["frameLayer"] = 8,
				["xTextOffset"] = 0,
				["y"] = 17,
				["frameStrata"] = 3,
				["width"] = 117,
				["yTextOffset"] = 0,
				["x"] = -98,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 16,
				["anchorText"] = "Center",
				["enable"] = true,
				["textheight"] = 12,
			},
			["currency"] = {
				["scale"] = 64,
				["Goal"] = {
				},
				["anchor"] = "BottomRight",
				["showBG"] = false,
				["frameLayer"] = 1,
				["lifeTime_Track"] = {
					[""] = {
					},
					["Artifact Points"] = {
					},
					["Gold"] = {
					},
				},
				["isTopToBottom"] = false,
				["alpha"] = 100,
				["width"] = 50,
				["y"] = 6,
				["x"] = -12,
				["frameStrata"] = 2,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["g"] = 1,
					["r"] = 1,
				},
				["enable"] = false,
				["ThisSession"] = {
					[""] = 0,
					["Artifact Points"] = 0,
					["Gold"] = 0,
				},
				["watchIndex"] = 2,
				["lifeTime"] = {
					[""] = 0,
					["Artifact Points"] = 0,
					["Gold"] = 0,
				},
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 10,
				["scale"] = 100,
				["alpha"] = 100,
				["y"] = -14,
				["x"] = -31,
				["mouseOverTooltip"] = true,
				["anchor"] = "TopRight",
				["enable"] = true,
				["frameStrata"] = 3,
			},
			["level"] = {
				["frameLayer"] = 3,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 25,
				["y"] = -19,
				["x"] = 72,
				["justifyH"] = 2,
				["height"] = 12,
				["anchor"] = "Center",
				["enable"] = true,
				["frameStrata"] = 4,
			},
			["padW"] = 3,
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = -6,
				["x"] = 10,
				["justifyH"] = 1,
				["height"] = 12,
				["enable"] = true,
				["anchor"] = "top",
				["frameStrata"] = 2,
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "percent",
				["y"] = -69,
				["x"] = -99,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textVert"] = 2,
				["LifeTime"] = 0,
				["leftOffset"] = 0,
				["frameStrata"] = 3,
				["alpha"] = 100,
				["width"] = 126,
				["bottomOffset"] = 100,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 91,
				["textX"] = 0,
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["power"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "percent",
				["y"] = -56,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 8,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 91,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["yTextOffset"] = 0,
				["textVert"] = 2,
				["textHori"] = 2,
				["textX"] = 0,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 127,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 3,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["x"] = -98,
				["topOffset"] = 0,
			},
			["icons"] = {
				["xShift"] = 0,
				["yShift"] = 0,
				["enable"] = true,
				["scale"] = 101,
				["spin"] = 137.513977050781,
				["isLeftToRight"] = false,
				["xFlex"] = 0,
				["s"] = false,
				["compress"] = 0,
				["isTopToBottom"] = false,
				["spacing"] = 7.99036026000977,
				["space"] = -13,
				["angle"] = 227,
				["alpha"] = 100,
				["width"] = 45,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 8,
				["frameLayer"] = 5,
				["IsLeftToRight"] = false,
				["rings"] = 1,
				["frameStrata"] = 4,
				["xArc"] = 0,
				["y"] = 4,
				["IsTopToBottom"] = true,
				["style"] = "ROUND",
				["reverse"] = false,
				["height"] = 45,
				["yArc"] = 0,
				["anchor"] = "Right",
				["x"] = -35,
			},
			["showInOverrideUI"] = false,
			["frameStrata"] = 4,
			["width"] = 232,
			["padH"] = 3,
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 1,
				["width"] = 100,
				["y"] = 16,
				["x"] = -39,
				["justifyH"] = 2,
				["anchor"] = "Center",
				["height"] = 12,
				["scale"] = 100,
				["frameStrata"] = 3,
			},
			["health"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 4,
				["mouseover"] = "percent",
				["y"] = -43,
				["x"] = -99,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["textVert"] = 2,
				["textX"] = 0,
				["scale"] = 91,
				["maxTextWidth"] = 300,
				["frameStrata"] = 3,
				["width"] = 126,
				["classColor"] = false,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["leftOffset"] = 0,
				["alpha"] = 100,
				["bottomOffset"] = 100,
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["model"] = {
				["zoom"] = 0,
				["clickThru"] = true,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 89,
				["y"] = -187,
				["justifyV"] = "CENTER",
				["width"] = 191,
				["rotation"] = 0,
				["x"] = 20,
				["justifyH"] = "CENTER",
				["anchor"] = "BottomRight",
				["height"] = 191,
				["enable"] = false,
				["deathEffect"] = false,
				["frameStrata"] = 2,
			},
			["height"] = 100,
			["buffs"] = {
				["alpha"] = 100,
				["isLeftToRight"] = true,
				["columns"] = 6,
				["frameLayer"] = 1,
				["scale"] = 64,
				["rows"] = 1,
				["frameStrata"] = 2,
				["enable"] = true,
				["y"] = -11,
				["x"] = -94,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomRight",
				["isTopToBottom"] = false,
				["showBG"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
			},
			["frameLayer"] = 4,
			["background"] = {
				["color"] = {
					["a"] = 0.5,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["r"] = 100,
					["g"] = 100,
					["b"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "TopRight",
				["inset"] = 0,
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 3,
				["width"] = 50,
				["y"] = -23,
				["x"] = -101,
				["height"] = 21,
				["enable"] = true,
				["scale"] = 100,
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			},
		},
		["target"] = {
			["overlay"] = {
				["y"] = -1,
				["x"] = 11,
				["frameLayer"] = 3,
				["enable"] = true,
				["frameStrata"] = 4,
				["anchor"] = "Center",
			},
			["debuffs"] = {
				["enable"] = true,
				["rows"] = 1,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "Bottom",
				["showBG"] = false,
				["columns"] = 6,
				["frameLayer"] = 1,
				["alpha"] = 100,
				["y"] = -39,
				["isTopToBottom"] = true,
				["frameStrata"] = 5,
				["reverse"] = false,
				["color"] = {
					["a"] = 1,
					["b"] = 0.0666666666666667,
					["g"] = 1,
					["r"] = 0,
				},
				["scale"] = 64,
				["isLeftToRight"] = true,
				["x"] = -39,
			},
			["resource"] = {
				["rotateIcons"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["g"] = 1,
					["r"] = 1,
				},
				["spacing"] = 3,
				["anchor"] = "Bottom",
				["angle"] = 0,
				["showBG"] = false,
				["columns"] = 5,
				["compress"] = 0,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["width"] = 50,
				["y"] = 11,
				["isTopToBottom"] = false,
				["style"] = "Bar",
				["frameLayer"] = 1,
				["height"] = 50,
				["x"] = -31,
				["scale"] = 91,
				["enable"] = true,
			},
			["scale"] = 1,
			["cast"] = {
				["textY"] = 0,
				["scale"] = 100,
				["multi"] = true,
				["sparkY"] = 0,
				["textheight"] = 12,
				["maxTextWidth"] = 98,
				["Sparkarc"] = 0,
				["backdropOpacity"] = 50,
				["showBG"] = false,
				["anchor"] = "Right",
				["textX"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["CurveOffset"] = 0,
				["orient"] = "HORIZONTAL",
				["alpha"] = 100,
				["frameLevel"] = 2,
				["frameLayer"] = 8,
				["xTextOffset"] = 0,
				["y"] = 17,
				["frameStrata"] = 3,
				["width"] = 117,
				["yTextOffset"] = 0,
				["x"] = -98,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 16,
				["anchorText"] = "Center",
				["enable"] = true,
				["textureName"] = "Blizzard",
			},
			["currency"] = {
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["g"] = 1,
					["r"] = 1,
				},
				["Goal"] = {
				},
				["anchor"] = "BottomRight",
				["lifeTime_Track"] = {
					[""] = {
					},
					["Artifact Points"] = {
					},
					["Gold"] = {
					},
				},
				["frameLayer"] = 1,
				["showBG"] = false,
				["isTopToBottom"] = false,
				["frameStrata"] = 2,
				["width"] = 50,
				["y"] = 6,
				["x"] = -12,
				["ThisSession"] = {
					[""] = 0,
					["Artifact Points"] = 0,
					["Gold"] = 0,
				},
				["enable"] = false,
				["scale"] = 64,
				["alpha"] = 100,
				["watchIndex"] = 2,
				["lifeTime"] = {
					[""] = 0,
					["Artifact Points"] = 0,
					["Gold"] = 0,
				},
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 10,
				["scale"] = 100,
				["alpha"] = 100,
				["y"] = -14,
				["x"] = -31,
				["mouseOverTooltip"] = true,
				["anchor"] = "TopRight",
				["enable"] = true,
				["frameStrata"] = 3,
			},
			["background"] = {
				["color"] = {
					["a"] = 0.5,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["r"] = 100,
					["g"] = 100,
					["b"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "TopRight",
				["inset"] = 0,
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 3,
				["width"] = 50,
				["y"] = -23,
				["x"] = -101,
				["height"] = 21,
				["enable"] = true,
				["scale"] = 100,
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			},
			["padW"] = 3,
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = -6,
				["x"] = 10,
				["justifyH"] = 1,
				["height"] = 12,
				["enable"] = true,
				["anchor"] = "top",
				["frameStrata"] = 2,
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "percent",
				["y"] = -69,
				["x"] = -99,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textVert"] = 2,
				["LifeTime"] = 0,
				["leftOffset"] = 0,
				["frameStrata"] = 3,
				["alpha"] = 100,
				["width"] = 126,
				["bottomOffset"] = 100,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 91,
				["textX"] = 0,
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["frameLayer"] = 4,
			["frameStrata"] = 4,
			["showInOverrideUI"] = false,
			["icons"] = {
				["xShift"] = 0,
				["yShift"] = 0,
				["enable"] = true,
				["scale"] = 101,
				["spin"] = 137.513977050781,
				["frameStrata"] = 4,
				["xFlex"] = 0,
				["s"] = false,
				["compress"] = 0,
				["isTopToBottom"] = false,
				["spacing"] = 7.99036026000977,
				["space"] = -13,
				["angle"] = 227,
				["alpha"] = 100,
				["width"] = 45,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 8,
				["frameLayer"] = 5,
				["IsLeftToRight"] = false,
				["rings"] = 1,
				["isLeftToRight"] = false,
				["xArc"] = 0,
				["y"] = 4,
				["IsTopToBottom"] = true,
				["style"] = "ROUND",
				["reverse"] = false,
				["height"] = 45,
				["yArc"] = 0,
				["anchor"] = "Right",
				["x"] = -35,
			},
			["width"] = 232,
			["height"] = 100,
			["health"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 4,
				["mouseover"] = "percent",
				["y"] = -43,
				["x"] = -99,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["textVert"] = 2,
				["textX"] = 0,
				["scale"] = 91,
				["maxTextWidth"] = 300,
				["alpha"] = 100,
				["width"] = 126,
				["classColor"] = false,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["leftOffset"] = 0,
				["frameStrata"] = 3,
				["bottomOffset"] = 100,
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 1,
				["width"] = 100,
				["y"] = 16,
				["x"] = -39,
				["justifyH"] = 2,
				["anchor"] = "Center",
				["height"] = 12,
				["scale"] = 100,
				["frameStrata"] = 3,
			},
			["model"] = {
				["zoom"] = 0,
				["clickThru"] = true,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 89,
				["y"] = -187,
				["justifyV"] = "CENTER",
				["width"] = 191,
				["rotation"] = 0,
				["x"] = 20,
				["justifyH"] = "CENTER",
				["anchor"] = "BottomRight",
				["height"] = 191,
				["enable"] = false,
				["deathEffect"] = false,
				["frameStrata"] = 2,
			},
			["padH"] = 3,
			["buffs"] = {
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["isLeftToRight"] = true,
				["columns"] = 6,
				["frameLayer"] = 1,
				["scale"] = 64,
				["rows"] = 1,
				["frameStrata"] = 2,
				["enable"] = true,
				["y"] = -11,
				["x"] = -94,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomRight",
				["isTopToBottom"] = false,
				["showBG"] = false,
				["alpha"] = 100,
			},
			["power"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "percent",
				["y"] = -56,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 8,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 91,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["yTextOffset"] = 0,
				["textVert"] = 2,
				["textHori"] = 2,
				["textX"] = 0,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 127,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 3,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["x"] = -98,
				["topOffset"] = 0,
			},
			["level"] = {
				["frameLayer"] = 3,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 25,
				["y"] = -19,
				["x"] = 72,
				["justifyH"] = 2,
				["height"] = 12,
				["anchor"] = "Center",
				["enable"] = true,
				["frameStrata"] = 4,
			},
		},
		["focustarget"] = {
			["overlay"] = {
				["y"] = -1,
				["x"] = 11,
				["frameLayer"] = 3,
				["enable"] = true,
				["frameStrata"] = 4,
				["anchor"] = "Center",
			},
			["debuffs"] = {
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 1,
					["b"] = 0.0666666666666667,
				},
				["rows"] = 1,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "Bottom",
				["showBG"] = false,
				["columns"] = 6,
				["frameLayer"] = 1,
				["isLeftToRight"] = true,
				["y"] = -39,
				["isTopToBottom"] = true,
				["alpha"] = 100,
				["reverse"] = false,
				["frameStrata"] = 5,
				["scale"] = 64,
				["enable"] = true,
				["x"] = -39,
			},
			["resource"] = {
				["rotateIcons"] = 0,
				["enable"] = true,
				["spacing"] = 3,
				["anchor"] = "Bottom",
				["angle"] = 0,
				["showBG"] = false,
				["columns"] = 5,
				["compress"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["g"] = 1,
					["r"] = 1,
				},
				["frameStrata"] = 2,
				["width"] = 50,
				["y"] = 11,
				["isTopToBottom"] = false,
				["style"] = "Bar",
				["scale"] = 91,
				["height"] = 50,
				["x"] = -31,
				["frameLayer"] = 1,
				["alpha"] = 100,
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -69,
				["x"] = -99,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textVert"] = 2,
				["LifeTime"] = 0,
				["leftOffset"] = 0,
				["frameStrata"] = 3,
				["alpha"] = 100,
				["width"] = 126,
				["bottomOffset"] = 100,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 91,
				["textX"] = 0,
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["padW"] = 3,
			["currency"] = {
				["scale"] = 64,
				["Goal"] = {
				},
				["anchor"] = "BottomRight",
				["showBG"] = false,
				["frameLayer"] = 1,
				["lifeTime_Track"] = {
					[""] = {
					},
					["Artifact Points"] = {
					},
					["Gold"] = {
					},
				},
				["isTopToBottom"] = false,
				["alpha"] = 100,
				["width"] = 50,
				["y"] = 6,
				["x"] = -12,
				["frameStrata"] = 2,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["g"] = 1,
					["r"] = 1,
				},
				["enable"] = false,
				["ThisSession"] = {
					[""] = 0,
					["Artifact Points"] = 0,
					["Gold"] = 0,
				},
				["watchIndex"] = 2,
				["lifeTime"] = {
					[""] = 0,
					["Artifact Points"] = 0,
					["Gold"] = 0,
				},
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 10,
				["scale"] = 100,
				["alpha"] = 100,
				["y"] = -14,
				["x"] = -31,
				["mouseOverTooltip"] = true,
				["anchor"] = "TopRight",
				["enable"] = true,
				["frameStrata"] = 3,
			},
			["level"] = {
				["frameLayer"] = 3,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 25,
				["y"] = -19,
				["x"] = 72,
				["justifyH"] = 2,
				["height"] = 12,
				["anchor"] = "Center",
				["enable"] = true,
				["frameStrata"] = 4,
			},
			["background"] = {
				["color"] = {
					["a"] = 0.5,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["r"] = 100,
					["g"] = 100,
					["b"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "TopRight",
				["inset"] = 0,
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 3,
				["width"] = 50,
				["y"] = -23,
				["x"] = -101,
				["height"] = 21,
				["enable"] = true,
				["scale"] = 100,
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			},
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = -6,
				["x"] = 10,
				["justifyH"] = 1,
				["height"] = 12,
				["enable"] = true,
				["anchor"] = "top",
				["frameStrata"] = 2,
			},
			["cast"] = {
				["textY"] = 0,
				["scale"] = 100,
				["multi"] = true,
				["textureName"] = "Blizzard",
				["sparkY"] = 0,
				["maxTextWidth"] = 98,
				["Sparkarc"] = 0,
				["backdropOpacity"] = 50,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["anchor"] = "Right",
				["textX"] = 0,
				["showBG"] = false,
				["CurveOffset"] = 0,
				["orient"] = "HORIZONTAL",
				["alpha"] = 100,
				["frameLevel"] = 2,
				["frameLayer"] = 8,
				["xTextOffset"] = 0,
				["y"] = 17,
				["frameStrata"] = 3,
				["width"] = 117,
				["yTextOffset"] = 0,
				["x"] = -98,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 16,
				["anchorText"] = "Center",
				["enable"] = true,
				["textheight"] = 12,
			},
			["frameLayer"] = 4,
			["icons"] = {
				["xShift"] = 0,
				["yShift"] = 0,
				["enable"] = true,
				["scale"] = 101,
				["spin"] = 137.513977050781,
				["isLeftToRight"] = false,
				["xFlex"] = 0,
				["s"] = false,
				["compress"] = 0,
				["isTopToBottom"] = false,
				["spacing"] = 7.99036026000977,
				["space"] = -13,
				["angle"] = 227,
				["alpha"] = 100,
				["width"] = 45,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 8,
				["frameLayer"] = 5,
				["IsLeftToRight"] = false,
				["rings"] = 1,
				["frameStrata"] = 4,
				["xArc"] = 0,
				["y"] = 4,
				["IsTopToBottom"] = true,
				["style"] = "ROUND",
				["reverse"] = false,
				["height"] = 45,
				["yArc"] = 0,
				["anchor"] = "Right",
				["x"] = -35,
			},
			["showInOverrideUI"] = false,
			["frameStrata"] = 4,
			["width"] = 232,
			["padH"] = 3,
			["health"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 4,
				["mouseover"] = "value",
				["y"] = -43,
				["x"] = -99,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["textVert"] = 2,
				["textX"] = 0,
				["scale"] = 91,
				["maxTextWidth"] = 300,
				["frameStrata"] = 3,
				["width"] = 126,
				["classColor"] = false,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["leftOffset"] = 0,
				["alpha"] = 100,
				["bottomOffset"] = 100,
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 1,
				["width"] = 100,
				["y"] = 16,
				["x"] = -39,
				["justifyH"] = 2,
				["anchor"] = "Center",
				["height"] = 12,
				["scale"] = 100,
				["frameStrata"] = 3,
			},
			["model"] = {
				["zoom"] = 0,
				["clickThru"] = true,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 89,
				["y"] = -187,
				["justifyV"] = "CENTER",
				["width"] = 191,
				["rotation"] = 0,
				["x"] = 20,
				["justifyH"] = "CENTER",
				["anchor"] = "BottomRight",
				["height"] = 191,
				["enable"] = false,
				["deathEffect"] = false,
				["frameStrata"] = 2,
			},
			["height"] = 100,
			["buffs"] = {
				["alpha"] = 100,
				["isLeftToRight"] = true,
				["columns"] = 6,
				["frameLayer"] = 1,
				["scale"] = 64,
				["rows"] = 1,
				["frameStrata"] = 2,
				["enable"] = true,
				["y"] = -11,
				["x"] = -94,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomRight",
				["isTopToBottom"] = false,
				["showBG"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
			},
			["power"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -56,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 8,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 91,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["yTextOffset"] = 0,
				["textVert"] = 2,
				["textHori"] = 2,
				["textX"] = 0,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 127,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 3,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["x"] = -98,
				["topOffset"] = 0,
			},
			["scale"] = 0.75,
		},
		["targettarget"] = {
			["overlay"] = {
				["y"] = -1,
				["x"] = 11,
				["frameLayer"] = 3,
				["enable"] = true,
				["frameStrata"] = 4,
				["anchor"] = "Center",
			},
			["debuffs"] = {
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 1,
					["b"] = 0.0666666666666667,
				},
				["rows"] = 1,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "Bottom",
				["showBG"] = false,
				["columns"] = 6,
				["frameLayer"] = 1,
				["isLeftToRight"] = true,
				["y"] = -39,
				["isTopToBottom"] = true,
				["alpha"] = 100,
				["reverse"] = false,
				["frameStrata"] = 5,
				["scale"] = 64,
				["enable"] = true,
				["x"] = -39,
			},
			["resource"] = {
				["rotateIcons"] = 0,
				["enable"] = true,
				["spacing"] = 3,
				["anchor"] = "Bottom",
				["angle"] = 0,
				["showBG"] = false,
				["columns"] = 5,
				["compress"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["g"] = 1,
					["r"] = 1,
				},
				["frameStrata"] = 2,
				["width"] = 50,
				["y"] = 11,
				["isTopToBottom"] = false,
				["style"] = "Bar",
				["scale"] = 91,
				["height"] = 50,
				["x"] = -31,
				["frameLayer"] = 1,
				["alpha"] = 100,
			},
			["scale"] = 0.75,
			["padW"] = 3,
			["currency"] = {
				["scale"] = 64,
				["Goal"] = {
				},
				["anchor"] = "BottomRight",
				["showBG"] = false,
				["frameLayer"] = 1,
				["lifeTime_Track"] = {
					[""] = {
					},
					["Artifact Points"] = {
					},
					["Gold"] = {
					},
				},
				["isTopToBottom"] = false,
				["alpha"] = 100,
				["width"] = 50,
				["y"] = 6,
				["x"] = -12,
				["frameStrata"] = 2,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["g"] = 1,
					["r"] = 1,
				},
				["enable"] = false,
				["ThisSession"] = {
					[""] = 0,
					["Artifact Points"] = 0,
					["Gold"] = 0,
				},
				["watchIndex"] = 2,
				["lifeTime"] = {
					[""] = 0,
					["Artifact Points"] = 0,
					["Gold"] = 0,
				},
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 10,
				["scale"] = 100,
				["alpha"] = 100,
				["y"] = -14,
				["x"] = -31,
				["mouseOverTooltip"] = true,
				["anchor"] = "TopRight",
				["enable"] = true,
				["frameStrata"] = 3,
			},
			["level"] = {
				["frameLayer"] = 3,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 25,
				["y"] = -19,
				["x"] = 72,
				["justifyH"] = 2,
				["height"] = 12,
				["anchor"] = "Center",
				["enable"] = true,
				["frameStrata"] = 4,
			},
			["cast"] = {
				["textY"] = 0,
				["scale"] = 100,
				["multi"] = true,
				["textureName"] = "Blizzard",
				["sparkY"] = 0,
				["maxTextWidth"] = 98,
				["Sparkarc"] = 0,
				["backdropOpacity"] = 50,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["anchor"] = "Right",
				["textX"] = 0,
				["showBG"] = false,
				["CurveOffset"] = 0,
				["orient"] = "HORIZONTAL",
				["alpha"] = 100,
				["frameLevel"] = 2,
				["frameLayer"] = 8,
				["xTextOffset"] = 0,
				["y"] = 17,
				["frameStrata"] = 3,
				["width"] = 117,
				["yTextOffset"] = 0,
				["x"] = -98,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 16,
				["anchorText"] = "Center",
				["enable"] = true,
				["textheight"] = 12,
			},
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = -6,
				["x"] = 10,
				["justifyH"] = 1,
				["height"] = 12,
				["enable"] = true,
				["anchor"] = "top",
				["frameStrata"] = 2,
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -69,
				["x"] = -99,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textVert"] = 2,
				["LifeTime"] = 0,
				["leftOffset"] = 0,
				["frameStrata"] = 3,
				["alpha"] = 100,
				["width"] = 126,
				["bottomOffset"] = 100,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 91,
				["textX"] = 0,
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["power"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -56,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 8,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 91,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["yTextOffset"] = 0,
				["textVert"] = 2,
				["textHori"] = 2,
				["textX"] = 0,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 127,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 3,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["x"] = -98,
				["topOffset"] = 0,
			},
			["frameStrata"] = 4,
			["showInOverrideUI"] = false,
			["icons"] = {
				["xShift"] = 0,
				["yShift"] = 0,
				["enable"] = true,
				["scale"] = 101,
				["spin"] = 137.513977050781,
				["isLeftToRight"] = false,
				["xFlex"] = 0,
				["s"] = false,
				["compress"] = 0,
				["isTopToBottom"] = false,
				["spacing"] = 7.99036026000977,
				["space"] = -13,
				["angle"] = 227,
				["alpha"] = 100,
				["width"] = 45,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 8,
				["frameLayer"] = 5,
				["IsLeftToRight"] = false,
				["rings"] = 1,
				["frameStrata"] = 4,
				["xArc"] = 0,
				["y"] = 4,
				["IsTopToBottom"] = true,
				["style"] = "ROUND",
				["reverse"] = false,
				["height"] = 45,
				["yArc"] = 0,
				["anchor"] = "Right",
				["x"] = -35,
			},
			["width"] = 232,
			["padH"] = 3,
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 1,
				["width"] = 100,
				["y"] = 16,
				["x"] = -39,
				["justifyH"] = 2,
				["anchor"] = "Center",
				["height"] = 12,
				["scale"] = 100,
				["frameStrata"] = 3,
			},
			["health"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 4,
				["mouseover"] = "value",
				["y"] = -43,
				["x"] = -99,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["textVert"] = 2,
				["textX"] = 0,
				["scale"] = 91,
				["maxTextWidth"] = 300,
				["frameStrata"] = 3,
				["width"] = 126,
				["classColor"] = false,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["leftOffset"] = 0,
				["alpha"] = 100,
				["bottomOffset"] = 100,
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["model"] = {
				["zoom"] = 0,
				["clickThru"] = true,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 89,
				["y"] = -187,
				["justifyV"] = "CENTER",
				["width"] = 191,
				["rotation"] = 0,
				["x"] = 20,
				["justifyH"] = "CENTER",
				["anchor"] = "BottomRight",
				["height"] = 191,
				["enable"] = false,
				["deathEffect"] = false,
				["frameStrata"] = 2,
			},
			["height"] = 100,
			["buffs"] = {
				["alpha"] = 100,
				["isLeftToRight"] = true,
				["columns"] = 6,
				["frameLayer"] = 1,
				["scale"] = 64,
				["rows"] = 1,
				["frameStrata"] = 2,
				["enable"] = true,
				["y"] = -11,
				["x"] = -94,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomRight",
				["isTopToBottom"] = false,
				["showBG"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
			},
			["frameLayer"] = 4,
			["background"] = {
				["color"] = {
					["a"] = 0.5,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["r"] = 100,
					["g"] = 100,
					["b"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "TopRight",
				["inset"] = 0,
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 3,
				["width"] = 50,
				["y"] = -23,
				["x"] = -101,
				["height"] = 21,
				["enable"] = true,
				["scale"] = 100,
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			},
		},
		["playerpet"] = {
			["overlay"] = {
				["y"] = -1,
				["x"] = 11,
				["frameLayer"] = 3,
				["enable"] = true,
				["frameStrata"] = 4,
				["anchor"] = "Center",
			},
			["debuffs"] = {
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 1,
					["b"] = 0.0666666666666667,
				},
				["rows"] = 1,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "Bottom",
				["showBG"] = false,
				["columns"] = 6,
				["frameLayer"] = 1,
				["isLeftToRight"] = true,
				["y"] = -39,
				["isTopToBottom"] = true,
				["alpha"] = 100,
				["reverse"] = false,
				["frameStrata"] = 5,
				["scale"] = 64,
				["enable"] = true,
				["x"] = -39,
			},
			["resource"] = {
				["rotateIcons"] = 0,
				["enable"] = true,
				["spacing"] = 3,
				["anchor"] = "Bottom",
				["angle"] = 0,
				["showBG"] = false,
				["columns"] = 5,
				["compress"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["g"] = 1,
					["r"] = 1,
				},
				["frameStrata"] = 2,
				["width"] = 50,
				["y"] = 11,
				["isTopToBottom"] = false,
				["style"] = "Bar",
				["scale"] = 91,
				["height"] = 50,
				["x"] = -31,
				["frameLayer"] = 1,
				["alpha"] = 100,
			},
			["scale"] = 1,
			["padW"] = 3,
			["currency"] = {
				["scale"] = 64,
				["Goal"] = {
				},
				["anchor"] = "BottomRight",
				["showBG"] = false,
				["frameLayer"] = 1,
				["lifeTime_Track"] = {
					[""] = {
					},
					["Artifact Points"] = {
					},
					["Gold"] = {
					},
				},
				["isTopToBottom"] = false,
				["alpha"] = 100,
				["width"] = 50,
				["y"] = 6,
				["x"] = -12,
				["frameStrata"] = 2,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["g"] = 1,
					["r"] = 1,
				},
				["enable"] = false,
				["ThisSession"] = {
					[""] = 0,
					["Artifact Points"] = 0,
					["Gold"] = 0,
				},
				["watchIndex"] = 2,
				["lifeTime"] = {
					[""] = 0,
					["Artifact Points"] = 0,
					["Gold"] = 0,
				},
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 10,
				["scale"] = 100,
				["alpha"] = 100,
				["y"] = -14,
				["x"] = -31,
				["mouseOverTooltip"] = true,
				["anchor"] = "TopRight",
				["enable"] = true,
				["frameStrata"] = 3,
			},
			["level"] = {
				["frameLayer"] = 3,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 25,
				["y"] = -19,
				["x"] = 72,
				["justifyH"] = 2,
				["height"] = 12,
				["anchor"] = "Center",
				["enable"] = true,
				["frameStrata"] = 4,
			},
			["cast"] = {
				["textY"] = 0,
				["scale"] = 100,
				["multi"] = true,
				["textureName"] = "Blizzard",
				["sparkY"] = 0,
				["maxTextWidth"] = 98,
				["Sparkarc"] = 0,
				["backdropOpacity"] = 50,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["anchor"] = "Right",
				["textX"] = 0,
				["showBG"] = false,
				["CurveOffset"] = 0,
				["orient"] = "HORIZONTAL",
				["alpha"] = 100,
				["frameLevel"] = 2,
				["frameLayer"] = 8,
				["xTextOffset"] = 0,
				["y"] = 17,
				["frameStrata"] = 3,
				["width"] = 117,
				["yTextOffset"] = 0,
				["x"] = -98,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 16,
				["anchorText"] = "Center",
				["enable"] = true,
				["textheight"] = 12,
			},
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = -6,
				["x"] = 10,
				["justifyH"] = 1,
				["height"] = 12,
				["enable"] = true,
				["anchor"] = "top",
				["frameStrata"] = 2,
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "percent",
				["y"] = -69,
				["x"] = -99,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textVert"] = 2,
				["LifeTime"] = 0,
				["leftOffset"] = 0,
				["frameStrata"] = 3,
				["alpha"] = 100,
				["width"] = 126,
				["bottomOffset"] = 100,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 91,
				["textX"] = 0,
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["power"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "percent",
				["y"] = -56,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 8,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 91,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["yTextOffset"] = 0,
				["textVert"] = 2,
				["textHori"] = 2,
				["textX"] = 0,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 127,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 3,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["x"] = -98,
				["topOffset"] = 0,
			},
			["frameStrata"] = 4,
			["showInOverrideUI"] = false,
			["icons"] = {
				["xShift"] = 0,
				["yShift"] = 0,
				["enable"] = true,
				["scale"] = 101,
				["spin"] = 137.513977050781,
				["isLeftToRight"] = false,
				["xFlex"] = 0,
				["s"] = false,
				["compress"] = 0,
				["isTopToBottom"] = false,
				["spacing"] = 7.99036026000977,
				["space"] = -13,
				["angle"] = 227,
				["alpha"] = 100,
				["width"] = 45,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 8,
				["frameLayer"] = 5,
				["IsLeftToRight"] = false,
				["rings"] = 1,
				["frameStrata"] = 4,
				["xArc"] = 0,
				["y"] = 4,
				["IsTopToBottom"] = true,
				["style"] = "ROUND",
				["reverse"] = false,
				["height"] = 45,
				["yArc"] = 0,
				["anchor"] = "Right",
				["x"] = -35,
			},
			["width"] = 232,
			["padH"] = 3,
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 1,
				["width"] = 100,
				["y"] = 16,
				["x"] = -39,
				["justifyH"] = 2,
				["anchor"] = "Center",
				["height"] = 12,
				["scale"] = 100,
				["frameStrata"] = 3,
			},
			["health"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 4,
				["mouseover"] = "percent",
				["y"] = -43,
				["x"] = -99,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["textVert"] = 2,
				["textX"] = 0,
				["scale"] = 91,
				["maxTextWidth"] = 300,
				["frameStrata"] = 3,
				["width"] = 126,
				["classColor"] = false,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["leftOffset"] = 0,
				["alpha"] = 100,
				["bottomOffset"] = 100,
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["model"] = {
				["zoom"] = 0,
				["clickThru"] = true,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 89,
				["y"] = -187,
				["justifyV"] = "CENTER",
				["width"] = 191,
				["rotation"] = 0,
				["x"] = 20,
				["justifyH"] = "CENTER",
				["anchor"] = "BottomRight",
				["height"] = 191,
				["enable"] = false,
				["deathEffect"] = false,
				["frameStrata"] = 2,
			},
			["height"] = 100,
			["buffs"] = {
				["alpha"] = 100,
				["isLeftToRight"] = true,
				["columns"] = 6,
				["frameLayer"] = 1,
				["scale"] = 64,
				["rows"] = 1,
				["frameStrata"] = 2,
				["enable"] = true,
				["y"] = -11,
				["x"] = -94,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomRight",
				["isTopToBottom"] = false,
				["showBG"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
			},
			["frameLayer"] = 4,
			["background"] = {
				["color"] = {
					["a"] = 0.5,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["r"] = 100,
					["g"] = 100,
					["b"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "TopRight",
				["inset"] = 0,
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 3,
				["width"] = 50,
				["y"] = -23,
				["x"] = -101,
				["height"] = 21,
				["enable"] = true,
				["scale"] = 100,
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			},
		},
	}
	
local function ADD(source, target)
	--you may now add new defaults at will. ~Goranaws
	if not target then 
		target = {}
	end
	if not source then
		--return
	end
	for key, value in pairs(source) do
		if type(value) == 'table' then
			target[key] =ADD(value, target[key])
		else
			target[key] = value
		end
	end
	return target
end
ADD(f, defaults)
	

for i, b in pairs(defaults) do
	if i ~= "player" then
		for add, info in pairs(Basics) do
			if not b[add] then
				b[add] = CopyTable(info)
			end
		end
	end
end

bar.DEFAULTS = defaults

local function check(source, target)
	--you may now add new defaults at will. ~Goranaws
	if not target then 
		target = {}
	end
	if not source then
		--return
	end
	for key, value in pairs(source) do
		if type(value) == 'table' then
			target[key] =check(value, target[key])
		else
			if (type(value) == 'boolean') then
				if target[key] == nil then
	target[key] = value
				end
 			else
 				target[key] = target[key] or value
 			end
		end
	end
	return target
end
bar.check = check

function bar:GetDefaults()
	local def
	if self and self.id and defaults[self.id] then 
		def = check(defaults[self.id])
	else
		def = CopyTable({
		scale = 1,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		point = 'Center',
		padW = 0,
		width = 232,
		y = 0,
		x = 0,
		padH = 0,
		height = 100,
	})
	end
	return def
end

local function Copy(source, destination, looped)
	if not destination then
		destination = {}
	end
	for i, b in pairs(CopyTable(source)) do
		if (type(b) == 'table') then
			destination[i] = Copy(b, destination[i], true)
		else
				
				destination[i] = b
		end
	end
	return destination
end


function bar:Reload()
	self.sets = self.sets or CopyTable(self:GetDefaults()) --check(self:GetDefaults(), self.sets)
	if self.Load then
		self:Load()
	end
	self:SetParent(self.parent or self:GetParent())
	self:Layout()
end

function bar:Unload()
				local p = Copy(self:GetDefaults(), bar.master.db.profile.frames[self.id])
                bar.master.db.profile.frames[self.id] = p
                self.sets = p
                self:Layout()
                self:Rescale()
                self:Reposition()
                self:Reanchor()

end

function bar:Disable()
	self:Free()
end
local layers = {
	"BACKGROUND",
	"LOW",
	"MEDIUM",
	"HIGH",
	"DIALOG",
	"FULLSCREEN",
	"FULLSCREEN_DIALOG",
	"TOOLTIP",
}

function bar:Layout()
	if self.UpdateComponents then
		self:UpdateComponents()
	else
		local pad = self:GetPadding()
		local w, h = self.sets.width + pad, self.sets.height + pad
		self:SetSize(w, h)
		self.sets.frameStrata = self.sets.frameStrata or 4
		self.sets.frameLayer = self.sets.frameLayer or 4
		local lay = layers[self.sets.frameStrata]
		self:SetFrameStrata(lay)
		self:SetFrameLevel(self.sets.frameLayer)
	end
end


bar.HIDER = CreateFrame("Frame")
bar.HIDER:Hide()











local templates = {virtual = {}}
bar.templates = templates


function bar:NewTemplate(name)
	templates.virtual[name] = {}
	return templates.virtual[name]
end


local function Merge(source, destination)
	if not destination then
		destination = {}
	end
	if not source then
		return destination
	end
	for i, b in pairs(source) do
		if (type(b) == 'table') then
			destination[i] = Merge(b, destination[i])
		else
			destination[i] = b
		end
	end
	return destination
end

bar.Merge = Merge

function bar:GetTemplate(template, name)
	local temp = templates.virtual[template]
	if temp then
		return Merge(CopyTable(templates.virtual[template]), bar:NewComponent(string.lower(name), template))
	else
		print("Template does not exsist: "..template)
	end
end






local mod = bar.master:NewModule('Frame')

local enabledFrames = {}

local defaults  = {
	frames = {
		player = true,
		target = true,
		targettarget = true,
		focus = true,
		focustarget = true,
		playerpet = true,
	},
	hide = {
		PlayerFrame = true,
		TargetFrame = true,
		FocusFrame = true,
	}
}

local function getSets()
	bar.master.db.profile.units = bar.master.db.profile.units or defaults
	bar.master.db.profile.units.hide = bar.master.db.profile.units.hide or bar.master.db.profile.units.disable or {
		PlayerFrame = true,
		TargetFrame = true,
		FocusFrame = true,
	}
	return bar.master.db.profile.units
end

bar.getSets = getSets

local def = {
			scale = 1,
			showInOverrideUI = false,
			showInPetBattleUI = false,
			point = 'Center',
			padW = 3,
			width = 232,
			y = 0,
			x = 0,
			padH = 3,
			height = 100,
			focus = {
				x = -42,
				y = -12,
				anchor = 'TopRight',
			},
			power = {
				anchor = 'TopRight',
				x = -106,
				y = -52,
				height = 12,
				width = (119/232)*100,
			},
			health = {
				anchor = 'TopRight',
				x = -106,
				y = -41,
				height = 12,
				width = (119/232)*100,
			},
			focus = {
				x = -42,
				y = -12,
				anchor = 'TopRight',
			},
			name = {
				width = 100,
				height = 12,
				anchor = 'Center',
				x = -50,
				y = 19,
				justifyH = 2,
			},
			icons = {
				width = 45,
				height = 45,
				style = 'ROUND',
				scale = 130,
				anchor = 'Right',
				angle  = 313,
				x = -45,
				y = 2,
				IsTopToBottom = true,
				IsLeftToRight = false,
			},
			level = {
				anchor = 'Center',
				x = 63,
				y = -16,
				justifyH = 2,				
			},
			background = {
				anchor = 'TopRight',
				x = -106,
				y = -22,
				width = (119/232)*100,
				height = 41,
				color = {
						r = 0,
						g = 0,
						b = 0,
						a = .5, 
				}
			},
			
			buffs = {
				enable = true,
				anchor = 'BottomLeft',
				x = 12,
				y = 6,
				scale = 64,
				rows = 1,
			},
			debuffs = {
				enable = true,
			},
			cast = {	
				frameLevel = 2,
				frameLayer = 4,
				scale = 100,
				alpha = 100,
				width = 117,
				y = 17,
				x = 7,
				anchor = 'Left',
				height = 16,
				enable = true,
				showBG = false,
				textheight = 12,
			},
		}

function mod:OnInitialize()
	bar.master.db.profile.units = bar.master.db.profile.units or defaults
	bar.unitLayouts = nil
	bar.unitLayouts = {Default = bar:GetDefaults()}
end

function mod:Load()
	wipe(enabledFrames)
	for unit, b in pairs(getSets().frames) do
		unit = string.lower(unit)
		local frame = bar:New(unit)
		bar.unitLayouts[unit] = frame.sets
		tinsert(enabledFrames, frame)
	end	

	for frameName, b in pairs(getSets().hide) do
		if frameName and _G[frameName] then
			_G[frameName]:SetParent(bar.HIDER)
		end
	end
end

function mod:Unload()
	if enabledFrames then
		for i, frame in pairs(enabledFrames) do
			bar.master.Frame:ForFrame(frame.id, 'Free')
			
				frame:Unload()
			
		end
	end
end


local lib = LibStub('LibSharedMedia-3.0')

bar.statusbarTextures = {
    ArcHUD = [[Interface\AddOns\Dominos_Units\textures\ArcHUD.tga]],
    ArcHUD2 = [[Interface\AddOns\Dominos_Units\textures\ArcHUD2.tga]],
    Bar = [[Interface\AddOns\Dominos_Units\textures\Bar.tga]],
    Bar2 = [[Interface\AddOns\Dominos_Units\textures\Bar2.tga]],
    BloodGlaives = [[Interface\AddOns\Dominos_Units\textures\BloodGlaives.tga]],
    BloodGlaives2 = [[Interface\AddOns\Dominos_Units\textures\BloodGlaives2.tga]],
    CleanCurves = [[Interface\AddOns\Dominos_Units\textures\CleanCurves.tga]],
    CleanCurves2 = [[Interface\AddOns\Dominos_Units\textures\CleanCurves2.tga]],
    CleanCurvesOut = [[Interface\AddOns\Dominos_Units\textures\CleanCurvesOut.tga]],
    CleanCurvesOut2 = [[Interface\AddOns\Dominos_Units\textures\CleanCurvesOut2.tga]],
    CleanTank = [[Interface\AddOns\Dominos_Units\textures\CleanTank.tga]],
    CleanTank2 = [[Interface\AddOns\Dominos_Units\textures\CleanTank2.tga]],
    ColorBar = [[Interface\AddOns\Dominos_Units\textures\ColorBar.tga]],
    ColorBar2 = [[Interface\AddOns\Dominos_Units\textures\ColorBar2.tga]],
    ComboCleanCurves = [[Interface\AddOns\Dominos_Units\textures\ComboCleanCurves.blp]],
    DHUD = [[Interface\AddOns\Dominos_Units\textures\DHUD.tga]],
    DHUD2 = [[Interface\AddOns\Dominos_Units\textures\DHUD2.tga]],
    FangRune = [[Interface\AddOns\Dominos_Units\textures\FangRune.tga]],
    FangRune2 = [[Interface\AddOns\Dominos_Units\textures\FangRune2.tga]],
    GemTank = [[Interface\AddOns\Dominos_Units\textures\GemTank.tga]],
    GlowArc = [[Interface\AddOns\Dominos_Units\textures\GlowArc.tga]],
    GlowArc2 = [[Interface\AddOns\Dominos_Units\textures\GlowArc2.tga]],
    HiBar = [[Interface\AddOns\Dominos_Units\textures\HiBar.tga]],
    HiBar2 = [[Interface\AddOns\Dominos_Units\textures\HiBar2.tga]],
    PillTank = [[Interface\AddOns\Dominos_Units\textures\PillTank.tga]],
    RivetBar = [[Interface\AddOns\Dominos_Units\textures\RivetBar.tga]],
    RivetBar2 = [[Interface\AddOns\Dominos_Units\textures\RivetBar2.tga]],
    RoundBar = [[Interface\AddOns\Dominos_Units\textures\RoundBar.tga]],
    RoundBar2 = [[Interface\AddOns\Dominos_Units\textures\RoundBar2.tga]],
    RuneBar = [[Interface\AddOns\Dominos_Units\textures\RuneBar.tga]],
    RuneBar2 = [[Interface\AddOns\Dominos_Units\textures\RuneBar2.tga]],
}



    for textureName, texturePath in pairs(bar.statusbarTextures) do
        if not lib.MediaTable.statusbar[textureName] then
            lib.MediaTable.statusbar[textureName] = texturePath
        end
    end



